/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __APPCONFIG_H__
#define __APPCONFIG_H__

#include <map>
#include <string>
using namespace std;

class CAppConfig
{
public:
	CAppConfig(void);
	~CAppConfig(void);

public:
	BOOL IsAutoSave(VOID) { return(m_fAutoSave); };
	VOID SetAutoSave(BOOL fVal_) { m_fAutoSave = fVal_; };
	BOOL SetValue(LPTSTR szName_, LPTSTR szVal_);
	BOOL SetValue(LPTSTR szName_, DWORD dwVal_);
	BOOL GetValue(LPTSTR szName_, LPTSTR* pszOutVal_, LPTSTR szDef_);
	BOOL GetValue(LPTSTR szName_, LPDWORD pdwOutVal_, DWORD dwDef_);
	BOOL Save(VOID);
	BOOL Open(HKEY hKey_, LPTSTR szPath_);
	VOID Close(VOID);

private:
	BOOL SaveValue(LPTSTR szName_, LPTSTR szVal_);
	BOOL SaveValue(LPTSTR szName_, DWORD dwVal_);
	BOOL __SetValue(LPTSTR szName_, LPTSTR szVal_);
	BOOL __SetValue(LPTSTR szName_, DWORD dwVal_);

private:
	typedef map<string, DWORD>  STR2DW;
	typedef map<string, string> STR2STR;
	typedef STR2DW::iterator    STR2DWIT;
	typedef STR2STR::iterator   STR2STRIT;

private:
	STR2DW				m_mapStr2Dw;
	STR2STR				m_mapStr2Str;

	HKEY				m_hKey;
	HKEY				m_hRootKey;

	BOOL				m_fWritable;
	BOOL				m_fOpened;
	BOOL				m_fAutoSave;
	LPTSTR				m_szPath;
	CRITICAL_SECTION	m_csStr2Dw;
	CRITICAL_SECTION	m_csStr2Str;
};

#endif // __APPCONFIG_H__
