/*  BotikBalance - User's account balance informer for Botik Network 
 *                 for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2005 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* Sorry for the long lines in the sources, I have wide screen... ;-)
 */

#ifndef __SCRIPTHOST_H__
#define __SCRIPTHOST_H__

#include <botikbalanceobj.h>

class CScriptHost : public IActiveScriptSite {
public:
	CScriptHost();
	~CScriptHost();

	// IUnknown
	virtual HRESULT	__stdcall QueryInterface(const IID &, void**);
	virtual ULONG	__stdcall AddRef(void);
	virtual ULONG	__stdcall Release(void);

	// IActiveScript Site.
	virtual HRESULT __stdcall GetLCID(LCID*);
	virtual HRESULT __stdcall GetDocVersionString(BSTR*);
	virtual HRESULT __stdcall OnEnterScript(void);
	virtual HRESULT __stdcall OnLeaveScript(void);
	virtual HRESULT __stdcall OnScriptError(IActiveScriptError*);
	virtual HRESULT __stdcall OnScriptTerminate(const VARIANT*, const EXCEPINFO*);
	virtual HRESULT __stdcall OnStateChange(SCRIPTSTATE);
	virtual HRESULT __stdcall GetItemInfo(LPCOLESTR, DWORD, IUnknown**, ITypeInfo**);

	// CScriptHost
	static CScriptHost* CreateObject();
	BOOL Init(VOID);
	CBotikBalanceObj* GetBotikBalanceObj() {return(m_pBBO);};

private:
	LONG				m_cRef;
	ITypeInfo*			m_pITypeInfo;
	ITypeLib*			m_pITypeLib;
	IUnknown*			m_pIBBO;
	CBotikBalanceObj*	m_pBBO;
};

#endif // __SCRIPTHOST_H__
